import request from "request-promise-native";
import { Message } from "discord.js";
import { CommandSet, Command } from "src/model/command";

@CommandSet
export class Inspire {

    async doInspire(msg: Message): Promise<void> {
        const result = await request("https://inspirobot.me/api?generate=true");
        msg.channel.send(`${msg.author.toString()} Here is a piece of my wisdom:`, {
            files: [ result ]
        });
    }

    @Command({ pattern: "inspire me", documentation: {description: "Generates an inspiring quote just for you", example: "inspire me"}})
    inspire(msg: Message): void {
        this.doInspire(msg);
    }
}